#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
const ll MAXN = 1e6 + 6;
const ll inf = 1e17 + 7;
const ll mod = 998244353;
const ll prod = 53;
mt19937 rnd(2);

int main() {
    ll t;
    cin >> t;
    ll n, m, a;
    cin >> n >> m;
    ll cnt[2];
    cnt[0] = 0;
    cnt[1] = 0;
    vector<ll> arr;
    vector<ll> arr1;
    string s1;
    for (int i = 0; i < n; i++) {
        cin >> a;
        arr1.push_back(a);
        cnt[a % 2]++;
    }
    string s;
    cin >> s1;
    if (cnt[0] > 0 && cnt[1] > 0) {
        cout << "No" << "\n";
        return 0;
    }
    cout << "Yes" << "\n";
    cout << (m + 1) / 2 << "\n";
}
